### B. Cells Coloring

若我们已经确定了哪些格子不染 $0$，构建一个二分图，若 $(i,j)$ 不染 $0$ 则连边 $(i,j')$。

引理：$k=\max_x deg_x$。其中 $x$ 是任意左部点或右部点。

证明：考虑增量 + 调整。每次插入一条边 $(x,y')$ 并给其染色，由于 $deg_x\leq k$，必然能找到一个颜色 $u$ 使得 $x$ 满足限制。若此时 $y'$ 不满足限制，则问题转化为将原先 $y'$ 相邻的颜色为 $u$ 的边修改为一个 $y'$ 满足限制的颜色 $v$。若此时原先 $y'$ 相邻的颜色为 $v$ 的边的另一端 $z$ 又不满足限制，我们再要求与 $z$ 相邻的颜色为 $v$ 的边的颜色改成 $u$。发现问题的形式和之前等价，递归处理。一旦不存在后继边或得到偶环即找到了方案。由于图是二分图，这样下去不会得到奇环，于是必定能做到。

于是我们可以枚举 $k$，接下来就是删掉最少的边使得 $\max_x deg_x\leq k$。这是一个每个点可以匹配至多 $k$ 个点的二分图最大匹配，直接网络流即可。一个有效的优化是，我们可以以升序枚举 $k$，这样每次可以在 $k-1$ 的残量网络上直接加容量。

### D. Contests

首先发现除了最后一步，每一步肯定是跳到某场比赛中排名最前的能跳到的选手。

考虑倍增。$f_{i,k}$ 表示跳了 $2^i$ 步，在第 $k$ 场比赛中最前能跳到的选手。每次枚举下次跳到哪场比赛最前的选手进行转移。

查询是类似的。复杂度为 $O((n+q)m^2\log n)$。