## Streets 解题报告

下设 $n, m$ 同级。

设选取矩形的左右边界横坐标为 $x_1, x_2(x_1\leq x_2)$，权值为 $a_1, a_2$，上下边界的纵坐标为 $y_1, y_2(y_1\leq y_2)$，权值为 $b_1, b_2$，则矩形的代价可写为 $(x_2 - x_1)(b_1 + b_2) + (y_2 - y_1)(a_1 + a_2)$。

对于固定的 $x_2 - x_1$，我们会最小化 $a_1 + a_2$。因此，设 $va_i$ 表示当 $x_2 - x_1 = i$ 时，最小的 $a_1 + a_2$，同理设 $vb_i$ 表示当 $y_2 - y_1 = i$ 时，最小的 $b_1 + b_2$。可以 $\mathcal{O}(n ^ 2)$ 暴力求解。因为有 $\min + $ 卷积的限制所以无法做到更快。

枚举 $i$，则问题形如找到最大的 $j$，使得 $f(i, j) = i\times vb_j + j\times va_i\leq c$。若将 $(j, vb_j)$ 看成平面上的点，则问题转化为求直线下点的横坐标最大值。

考虑二分答案，这样相当于判直线下是否有一个后缀上的某点，可以找到该后缀所有点的凸包在某个斜率下的切点，并判断对应切点权值是否不大于 $c$。

- 斜率：将判断式变形为 $vb_j\leq \dfrac {c - j\times va_i} i$，可知斜率为 $-\dfrac {va_i} i$。
- 对于凸包上相邻两点 $P_{j_1}$ 和 $P_{j_2}(j_1 < j_2)$，$(j_2, vb_{j_2})$ 比 $(j_1, vb_{j_1})$ 更优当且仅当 $\dfrac {vb_{j_2} - vb_{j_1}} {j_2 - j_1} < -\dfrac {va_i} i$，变形得 $f(i, j_2) < f(i, j_1)$。

这样，用线段树维护区间形成的点的凸包，结合凸包上二分，可以做到 $\mathcal{O}(n ^ 2 + TV\log ^ 2 n\log V)$，其中 $V$ 是值域。

我们有一个技巧：从后往前枚举每个点，并实时维护加入每个点 $P_{j_1}$ 后凸包内下一个点 $P_{j_2}$，并从 $j_1$ 向 $j_2$ 连边，形成一棵根向操作树。对操作树树剖，则一次查询 $\log$ 条链上的凸包，但由于斜率单调，可以先 $\mathcal{O}(1)$ 判断切点是否在凸包内，若非则跳过，否则在凸包内二分。单次判定 $\mathcal{O}(\log n)$，时间复杂度 $\mathcal{O}(n ^ 2 + TV\log n\log V)$。

对每个 $i$ 都二分太浪费了。注意到答案形如 $\max\limits_{f(i, j)\leq c} ij$，考虑从大到小枚举 $i$，并维护指针 $p$ 表示可以更新答案的 $j$ 的最小值。这样，若 $f(i, p)\leq c$ 则用 $ip$ 更新答案并不断增加 $p$ 直到 $p > V$ 或 $f(i, p) > c$，则当 $i$ 减小时 $p$ 不降，只需进行 $\mathcal{O}(V)$ 次判定直线是否有一段后缀上的某点。时间复杂度 $\mathcal{O}(n ^ 2 + TV\log n)$，可以通过。

Alternative solution：从后往前做凸包，记录每个点弹出了哪些点，这样维护 $p$ 增大的实时后缀凸包就很容易了。摆烂人场上用该方法通过本题。
