## Tree 解题报告

题目相当于用最少的链和反链数量覆盖一棵有根树。

如果一个点被反链覆盖，但它的儿子没有被反链覆盖，因为必然存在一条链经过它的儿子，所以必然存在一条链经过它，将覆盖该点的反链调整为覆盖它的儿子，答案不会变劣。

因此，每添加一条反链，都相当于剥去当前树上的所有叶子。设 $f_i$ 表示 $i$ 的子树内最深的叶子与 $i$ 的距离，这里距离定义为简单路径上的点数，容易证明 $i$ 会被第 $f_i$ 条反链覆盖。

假设我们不再添加反链，则每个叶子至少对应一条链，且每条链可以覆盖至少一个叶子，所以需要的链的数量为叶子数量。

如果我们用了 $j - 1$ 条反链，那么 $f_i = j$ 的节点 $i$ 会裸露成叶子。因此，设 $cnt_j$ 表示 $f_i = j$ 的 $i$ 的数量，则 $\min\limits_{j = 1} ^ n cnt_j + j - 1$ 即为所求。时间复杂度 $\mathcal{O}(n)$。

可以通过长链剖分做到同样复杂度。